/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <X11/Xlib.h>
#ifdef XPM
#include "xpm.h"
#endif /* XPM */
#include "puck.h"
#include "xpuck.xpm"

struct my_colors {
	unsigned char r,g,b;
	long p;
} color[] = {
	{ 255, 0, 0 },	/* Red */		/* 0 */
	{ 50, 200, 50 },  /* Green */		/* 1 */
	{ 0, 0, 255 },	/* Blue */		/* 2 */
	{ 238, 221, 130 }, /* LightGoldenrod */	/* 3 */
	{ 179, 179, 179 }, /* gray70 */		/* 4 */
	{ 229, 229, 229 }, /* gray90 */		/* 5 */
	{ 0x93, 0xb9, 0xdc }, /* SkyBlue */	/* 6 */
	{ 210, 180, 140 }, /* Tan */		/* 7 */
	{ 218, 165, 32 }, /* Goldenrod */	/* 8 */
	{ 179, 100, 100 }, /* red */		/* 9 */
	{ 229, 150, 150 }, /* red */		/* 10 */
};

extern Display *dpy;
extern Window field;
extern GC gc;
extern XFontStruct * font[];
extern long black,white;
extern long depth;

extern Game game;

static Pixmap bg;

int xpm_get_image();

void
create_pixmaps()
{
	int depth;
	int n;
	char text[256];
	XPoint	poly[4];

	allocate_colors();

	depth = DefaultDepth(dpy,DefaultScreen(dpy));
	bg = XCreatePixmap(dpy,field,FIELD_WIDTH,FIELD_HEIGHT,depth);

	XSetForeground(dpy,gc,black);
	XFillRectangle(dpy,bg,gc,0,0,FIELD_WIDTH,FIELD_HEIGHT);

	XSetForeground(dpy,gc,get_color(6));
	XPOINT(poly[0],0,-GAME_WIDTH/2,0);
	XPOINT(poly[1],GAME_DEPTH,-GAME_WIDTH/2,0);
	XPOINT(poly[2],GAME_DEPTH, GAME_WIDTH/2,0);
	XPOINT(poly[3],0, GAME_WIDTH/2,0);
	XFillPolygon(dpy,bg,gc,poly,4,Convex,CoordModeOrigin);

	XSetForeground(dpy,gc,white);
	XSetLineAttributes(dpy,gc,2,LineSolid,CapButt,JoinBevel);

	XSetFont(dpy,gc,font[FONT_TEXT]->fid);
	for(n=0; n<=GAME_DEPTH; n+=100)
	{
		XSetLineAttributes(dpy,gc,2,LineSolid,CapButt,JoinBevel);
		if (n == GAME_DEPTH/2)
		{
			XSetLineAttributes(dpy,gc,1,LineDoubleDash,CapButt,JoinBevel);
		}
		else
		if (n>300 && n < (GAME_DEPTH-300))
		{
			continue;
		}
		if (n>=GAME_DEPTH-300)
		{
			XSetLineAttributes(dpy,gc,1,LineSolid,CapButt,JoinBevel);
		}
		sprintf(text,"%d",n);
		XDrawLine(dpy,bg,gc, XY(n,-GAME_WIDTH/2,0), XY(n,GAME_WIDTH/2,0) );
	}
	for(n=-GAME_WIDTH/2; n<=GAME_WIDTH/2; n+=100)
	{
		XSetLineAttributes(dpy,gc,2,LineSolid,CapButt,JoinBevel);
		XDrawLine(dpy,bg,gc, XY(0,n,0), XY(GAME_PLAYER_ZONE,n,0));
		XSetLineAttributes(dpy,gc,1,LineSolid,CapButt,JoinBevel);
		XDrawLine(dpy,bg,gc, XY(GAME_DEPTH-GAME_PLAYER_ZONE,n,0), XY(GAME_DEPTH,n,0));
	}

	XSetLineAttributes(dpy,gc,1,LineSolid,CapButt,JoinBevel);

	XSetForeground(dpy,gc,get_color(9));
	XPOINT(poly[0],0,-GAME_WIDTH/2,0);
	XPOINT(poly[1],0,-GAME_WIDTH/2,GAME_BORDER);
	XPOINT(poly[2],GAME_DEPTH,-GAME_WIDTH/2,GAME_BORDER);
	XPOINT(poly[3],GAME_DEPTH,-GAME_WIDTH/2,0);
	XFillPolygon(dpy,bg,gc,poly,4,Convex,CoordModeOrigin);

	XPOINT(poly[0],0, GAME_WIDTH/2,0);
	XPOINT(poly[1],0, GAME_WIDTH/2,GAME_BORDER);
	XPOINT(poly[2],GAME_DEPTH, GAME_WIDTH/2,GAME_BORDER);
	XPOINT(poly[3],GAME_DEPTH, GAME_WIDTH/2,0);
	XFillPolygon(dpy,bg,gc,poly,4,Convex,CoordModeOrigin);

	XSetForeground(dpy,gc,get_color(10));
	XPOINT(poly[0],0,-GAME_WIDTH/2,GAME_BORDER);
	XPOINT(poly[1],0,-GAME_WIDTH,GAME_BORDER);
	XPOINT(poly[2],GAME_DEPTH,-GAME_WIDTH,GAME_BORDER);
	XPOINT(poly[3],GAME_DEPTH,-GAME_WIDTH/2,GAME_BORDER);
	XFillPolygon(dpy,bg,gc,poly,4,Convex,CoordModeOrigin);

	XPOINT(poly[0],0, GAME_WIDTH/2,GAME_BORDER);
	XPOINT(poly[1],0, GAME_WIDTH,GAME_BORDER);
	XPOINT(poly[2],GAME_DEPTH, GAME_WIDTH,GAME_BORDER);
	XPOINT(poly[3],GAME_DEPTH, GAME_WIDTH/2,GAME_BORDER);
	XFillPolygon(dpy,bg,gc,poly,4,Convex,CoordModeOrigin);

	XSetLineAttributes(dpy,gc,1,LineSolid,CapButt,JoinBevel);
	XDrawLine(dpy,bg,gc, XY(GAME_DEPTH-GAME_PLAYER_ZONE,-GAME_WIDTH/2,0), XY(GAME_PLAYER_ZONE,-GAME_WIDTH/2,0));
	XDrawLine(dpy,bg,gc, XY(GAME_DEPTH-GAME_PLAYER_ZONE, GAME_WIDTH/2,0), XY(GAME_PLAYER_ZONE, GAME_WIDTH/2,0));

	if (xpm_get_image() == 0)
	{
		puck_man();
	}
	XFlush(dpy);
}

clear_field()
{
	XSetWindowBackground(dpy,field,white);
	XClearWindow(dpy,field);
	XFlush(dpy);
}

draw_field()
{
	XSetWindowBackgroundPixmap(dpy,field,bg);
	XClearWindow(dpy,field);
	XFlush(dpy);
}

/* Set up colors for color screens */
allocate_colors()
{
	int n;
	XColor          def;
	Colormap        cmap;

	cmap = DefaultColormap(dpy, DefaultScreen(dpy));
	def.flags = DoRed | DoGreen | DoBlue;
	def.pad = 0;
	for(n=0; n < sizeof(color)/sizeof(struct my_colors); n++)
	{
		def.red = color[n].r << 8;
		def.green = color[n].g << 8;
		def.blue = color[n].b << 8;
		XAllocColor(dpy, cmap, &def);
		color[n].p = def.pixel;
	}
}

/* Method to retrieve a color */
long
get_color(int n)
{
	return color[n].p;
}

int
xpm_get_image()
{
#ifdef XPM
	XpmAttributes attributes;
	Pixmap mask,img;
	int status;
	char *failure;
	int x_org,y_org;

	if (game.opponent_xpm_file[0] == 0)
	{
		return 0;
	}
	attributes.valuemask = XpmColormap | XpmDepth | XpmCloseness;
	attributes.depth = depth;
	attributes.closeness = 1;
	attributes.colormap = DefaultColormap(dpy, DefaultScreen(dpy));
	status = XpmReadFileToPixmap(dpy,field,game.opponent_xpm_file,&img,&mask,&attributes);
	switch (status)
	{
		case XpmOpenFailed:
			failure = "Can't open file";
			break;
		case XpmFileInvalid:
			failure = "Not a valid XPM file";
			break;
		case XpmNoMemory:
			failure = "Not enough memory on server";
			break;
		case XpmColorFailed:
			failure = "Can't allocate colors";
			break;
	}
	if (status < 0)
	{
		printf("Failed to read %s (reason : %s)\n", game.opponent_xpm_file,failure);
		return 0;
	}
	x_org = FIELD_WIDTH/2-attributes.width/2;
	y_org = proj_y(GAME_DEPTH,0,0)-attributes.height;
	XSetClipMask(dpy,gc,mask);
	XSetClipOrigin(dpy,gc,x_org,y_org);
	XCopyArea(dpy,img,bg,gc,0,0,attributes.width,attributes.height,x_org,y_org);
	XSetClipMask(dpy,gc,None);
	return 1;
#else
	return 0;
#endif /* XPM */
}

puck_man()
{
	int width,height;
	int ncolor;
	int x,y,c,x_org,y_org;
	XColor          *pcolor;
	Colormap        cmap;
	long	def,pixel;
	char dummy,col;

	cmap = DefaultColormap(dpy, DefaultScreen(dpy));

	sscanf(xpuck[0],"%d %d %d",&width,&height,&ncolor);
	pcolor = (XColor *)malloc(ncolor*sizeof(XColor));
	for(c=1; c<=ncolor; c++)
	{
		sscanf(xpuck[c],"%c c #%x",&dummy,&def);
		if (dummy == '.')
		{
			pcolor[c-1].pixel = black;
			continue;
		}
		pcolor[c-1].flags = DoRed | DoGreen | DoBlue;
		pcolor[c-1].pad = 0;
		pcolor[c-1].red = (def>>16)<<8;
		pcolor[c-1].green = ((def&0xff00)>>8)<<8;
		pcolor[c-1].blue = (def&0xff)<<8;
		XAllocColor(dpy, cmap, &pcolor[c-1]);
	}
	x_org = FIELD_WIDTH/2-width/2;
	y_org = proj_y(GAME_DEPTH,0,0)-height;
	for(y=0; y < height; y++)
	{
		for(x=0; x < width; x++)
		{
			col = xpuck[y+ncolor+1][x];
			pixel = black;
			for(c=1; c<=ncolor; c++)
			{
				if (xpuck[c][0] == col)
				{
					pixel = pcolor[c-1].pixel;
					break;
				}
			}
			XSetForeground(dpy,gc,pixel);
			XDrawPoint(dpy,bg,gc,x+x_org,y+y_org);
		}
	}
	free(pcolor);
}
