/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include "puck.h"

#define fabs(r) (r < 0.0 ? -r : r)

extern Game   game;
extern Racket racket;
extern Racket racket2;
Puck puck;

#define STEP 100.0

void
check_colision_racket_with_puck()
{
	float rdx,rdy,rx,ry;
	float pdx,pdy,px,py;
	int n;

	if (game.state != S_PLAY)
	{
		return;
	}

	/* Collision with Racket */
	if (puck.x-PUCK_WIDTH/2 < racket.x || puck.x-PUCK_WIDTH/2 < racket.last_x)
	{
		rdx = (racket.x-racket.last_x)/STEP;
		rdy = (racket.y-racket.last_y)/STEP;
		px = puck.x;
		py = puck.y;
		rx = racket.last_x;
		ry = racket.last_y;
		for(n=0;n<STEP;n++)
		{
			if ( (px-PUCK_WIDTH/2 < rx)
			  && (px+PUCK_WIDTH/2 > rx)
			  && (py+PUCK_WIDTH/2 > ry-RACKET_WIDTH/2)
			  && (py-PUCK_WIDTH/2 < ry+RACKET_WIDTH/2) ) 
			{
				puck.dx = -puck.dx+(racket.dx)/RACKET_DX_FACT;
				puck.dy = puck.dy+(racket.dy)/RACKET_DY_FACT;
				if ((fabs(puck.dx) + fabs(puck.dy)) > PUCK_DXY_MAX)
				{
					float ratio;

					ratio = PUCK_DXY_MAX/(fabs(puck.dx) + fabs(puck.dy));
					puck.dx *= ratio;
					puck.dy *= ratio;
				}
				if (racket.dx < 0)
				{
					puck.x = racket.x-PUCK_WIDTH/2;
					advance_puck();
				}
				if (racket.dx > 0)
				{
					puck.x = racket.x+PUCK_WIDTH/2;
					advance_puck();
				}
				return;
			}
			rx += rdx;
			ry += rdy;
		}
	}

	/* Collision with Racket2 */
	if (puck.x+PUCK_WIDTH/2 > racket2.x || puck.x+PUCK_WIDTH/2 > racket2.last_x)
	{
		rdx = (racket2.x-racket2.last_x)/STEP;
		rdy = (racket2.y-racket2.last_y)/STEP;
		px = puck.x;
		py = puck.y;
		rx = racket2.last_x;
		ry = racket2.last_y;
		for(n=0;n<STEP;n++)
		{
			if ( (px-PUCK_WIDTH/2 < rx)
			  && (px+PUCK_WIDTH/2 > rx)
			  && (py+PUCK_WIDTH/2 > ry-RACKET_WIDTH/2)
			  && (py-PUCK_WIDTH/2 < ry+RACKET_WIDTH/2) ) 
			{
				puck.dx = -puck.dx+(racket2.dx)/RACKET_DX_FACT;
				puck.dy = puck.dy+(racket2.dy)/RACKET_DY_FACT;
				if ((fabs(puck.dx) + fabs(puck.dy)) > PUCK_DXY_MAX)
				{
					float ratio;

					ratio = PUCK_DXY_MAX/(fabs(puck.dx) + fabs(puck.dy));
					puck.dx *= ratio;
					puck.dy *= ratio;
				}
				if (racket2.dx < 0)
				{
					puck.x = racket2.x-PUCK_WIDTH/2;
					advance_puck();
				}
				if (racket2.dx > 0)
				{
					puck.x = racket2.x+PUCK_WIDTH/2;
					advance_puck();
				}
				return;
			}
			rx += rdx;
			ry += rdy;
		}
	}
}

void
check_colision_puck_with_rackets()
{
	float rdx,rdy,rx,ry;
	float pdx,pdy,px,py;
	int n;

	if (game.state != S_PLAY)
	{
		return;
	}

	/* Collision with Racket */
	if (puck.x-PUCK_WIDTH/2 < racket.x)
	{
		pdx = (puck.x-puck.last_x)/STEP;
		pdy = (puck.y-puck.last_y)/STEP;
		px = puck.last_x;
		py = puck.last_y;
		rx = racket.x;
		ry = racket.y;
		for(n=0;n<STEP;n++)
		{
			if ( (px-PUCK_WIDTH/2 < rx)
			  && (px+PUCK_WIDTH/2 > rx)
			  && (py+PUCK_WIDTH/2 > ry-RACKET_WIDTH/2)
			  && (py-PUCK_WIDTH/2 < ry+RACKET_WIDTH/2) ) 
			{
				puck.dx = -puck.dx/PUCK_DX_FACT;
				puck.dy = puck.dy/PUCK_DY_FACT;
				if (puck.dx < 0)
				{
					puck.x = racket.x-PUCK_WIDTH/2;
					advance_puck();
				}
				if (puck.dx > 0)
				{
					puck.x = racket.x+PUCK_WIDTH/2;
					advance_puck();
				}
				return;
			}
			px += pdx;
			py += pdy;
		}
	}

	/* Collision with Racket2 */
	if (puck.x+PUCK_WIDTH/2 > GAME_DEPTH-GAME_PLAYER_ZONE)
	{
		/* printf("Check at P( %4.0f %4.0f )",puck.x,puck.y); */
		pdx = (puck.x-puck.last_x)/STEP;
		pdy = (puck.y-puck.last_y)/STEP;
		px = puck.last_x;
		py = puck.last_y;
		rx = racket2.x;
		ry = racket2.y;
		for(n=0;n<STEP;n++)
		{
			if ( (px-PUCK_WIDTH/2 < rx)
			  && (px+PUCK_WIDTH/2 > rx)
			  && (py > ry-RACKET_WIDTH/2)
			  && (py < ry+RACKET_WIDTH/2) ) 
			{
				puck.dx = -puck.dx/PUCK_DX_FACT;
				puck.dy = puck.dy/PUCK_DY_FACT;
				if (puck.dx > 0)
				{
					puck.x = racket2.x+PUCK_WIDTH/2;
					advance_puck();
				}
				if (puck.dx < 0)
				{
					puck.x = racket2.x-PUCK_WIDTH/2;
					advance_puck();
				}
				/* printf("   Impact.\n"); */
				return;
			}
			px += pdx;
			py += pdy;
		}
		/* printf("\n"); */
	}
}
