/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <stdio.h>
#include "puck.h"

extern Game game;
extern Racket racket,racket2;
extern Puck puck;

extern draw_puck(int), draw_racket(int), draw_racket2(int);

#define MAX_FRAME 50
static int current_frame = 0;
static struct s_frame {
	float px,py;
	float rx,ry;
	float ox,oy;
} frame[MAX_FRAME];

redraw()
{
	if (game.state != S_PLAY && game.state != S_REPLAY)
	{
		/* No need to draw puck */
		if (racket2.last_X != racket2.x || racket2.last_Y != racket2.y)
		{
			draw_racket2(0);
		}
		draw_racket2(1);
		if (racket.last_X != racket.x || racket.last_Y != racket.y)
		{
			draw_racket(0);
		}
		draw_racket(1);
	}
	else
	{
		if (game.state == S_PLAY)
		{
			record();
		}
		if (puck.last_X != puck.x || puck.last_Y != puck.y)
		{
			draw_puck(0);
		}

		if (puck.x > racket2.x)
		{
			draw_puck(1);
		}
		if (racket2.last_X != racket2.x || racket2.last_Y != racket2.y)
		{
			draw_racket2(0);
		}
		draw_racket2(1);
		if (puck.x < racket2.x && puck.x > racket.x)
		{
			draw_puck(1);
		}
		if (racket.last_X != racket.x || racket.last_Y != racket.y)
		{
			draw_racket(0);
		}
		draw_racket(1);
		if (puck.x < racket.x)
		{
			draw_puck(1);
		}
	}
}

clear()
{
	draw_puck(0);
	draw_racket(0);
	draw_racket2(0);
}

record()
{
	frame[current_frame].px = puck.x;
	frame[current_frame].py = puck.y;
	frame[current_frame].rx = racket.x;
	frame[current_frame].ry = racket.y;
	frame[current_frame].ox = racket2.x;
	frame[current_frame].oy = racket2.y;
	current_frame = (current_frame+1) % MAX_FRAME;
}

replay(int mode)
{
	static int f;

	if (mode == 0)
	{
		/* Rewind */
		if (current_frame == MAX_FRAME-1)
		{
			f = 0;
		}
		else
		{
			f = current_frame+1;
		}
	}
	else
	{
		if (f == current_frame)
		{
			game.state = S_NEW;
		}
		else
		{
			puck.x = frame[f].px;
			puck.y = frame[f].py;
			racket.x = frame[f].rx;
			racket.y = frame[f].ry;
			racket2.x = frame[f].ox;
			racket2.y = frame[f].oy;
			f = (f+1) % MAX_FRAME;
		}
	}
}
