/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "puck.h"

extern int score(int,int);

extern GC              gc;
extern Display        *dpy;
extern long            white, black;
extern Window          frame, field, panel;
extern long            depth;
extern Game game;
extern Racket racket;
extern Racket racket2;

Puck puck;

void
init_puck()
{
	if (game.mode == GAME_AUTO || game.to_serve == 0)
	{
		puck.x = GAME_PLAYER_ZONE-PUCK_WIDTH;
	}
	else
	{
		puck.x = GAME_DEPTH-GAME_PLAYER_ZONE+PUCK_WIDTH;
	}
	puck.y = 0.0;
	puck.last_x = puck.x;
	puck.last_y = 0.0;
	puck.last_X = puck.x;
	puck.last_Y = 0.0;
	puck.dx = 0.0;
	puck.dy = 0.0;
}

void
advance_puck()
{
	puck.last_x = puck.x;
	puck.last_y = puck.y;
	puck.x += puck.dx;
	puck.y += puck.dy;
	if (puck.y-PUCK_WIDTH/2 < -GAME_WIDTH/2)
	{
		puck.y = -GAME_WIDTH/2+PUCK_WIDTH/2;
		puck.dy = -puck.dy;
	}
	if (puck.y+PUCK_WIDTH/2 >  GAME_WIDTH/2)
	{
		puck.y =  GAME_WIDTH/2-PUCK_WIDTH/2;
		puck.dy = -puck.dy;
	}
	check_colision_puck_with_rackets();
	if (puck.x < 0)
	{
		game.state = S_LOST;
		if (score(0,1)) game.state = S_GAME_OVER;
		return;
	}
	if (puck.x > GAME_DEPTH)
	{
		game.state = S_LOST;
		if (score(1,0)) game.state = S_GAME_OVER;
		return;
	}
}

void
draw_puck(int mode)
{
	long x1,y1,x2,y2;

	switch (mode)
	{
		case 0:
			x1 = proj_x(puck.last_X,puck.last_Y-PUCK_WIDTH/2,0);
			x2 = proj_x(puck.last_X,puck.last_Y+PUCK_WIDTH/2,0);
			y1 = proj_y(puck.last_X+PUCK_WIDTH/2,puck.last_Y,PUCK_HEIGHT);
			y2 = proj_y(puck.last_X-PUCK_WIDTH/2,puck.last_Y,0);
			XClearArea(dpy,field,x1-1,y1-1,x2-x1+2,y2-y1+2,False);
			break;
		case 1:
			XSetForeground(dpy,gc,get_color(3));
			x1 = proj_x(puck.x,puck.y-PUCK_WIDTH/2,0);
			x2 = proj_x(puck.x,puck.y+PUCK_WIDTH/2,0);
			y1 = proj_y(puck.x+PUCK_WIDTH/2,puck.y,0);
			y2 = proj_y(puck.x-PUCK_WIDTH/2,puck.y,0);
			XFillArc(dpy,field,gc,x1,y1,x2-x1,y2-y1,0,360*64);
			x1 = proj_x(puck.x,puck.y-PUCK_WIDTH/2,PUCK_HEIGHT);
			x2 = proj_x(puck.x,puck.y+PUCK_WIDTH/2,0);
			y1 = proj_y(puck.x,puck.y-PUCK_WIDTH/2,PUCK_HEIGHT);
			y2 = proj_y(puck.x,puck.y+PUCK_WIDTH/2,0);
			XSetForeground(dpy,gc,get_color(3));
			XFillRectangle(dpy,field,gc,x1,y1,x2-x1+1,y2-y1+1);
			x1 = proj_x(puck.x,puck.y-PUCK_WIDTH/2,PUCK_HEIGHT);
			x2 = proj_x(puck.x,puck.y+PUCK_WIDTH/2,PUCK_HEIGHT);
			y1 = proj_y(puck.x+PUCK_WIDTH/2,puck.y,PUCK_HEIGHT);
			y2 = proj_y(puck.x-PUCK_WIDTH/2,puck.y,PUCK_HEIGHT);
			XSetForeground(dpy,gc,get_color(8));
			XFillArc(dpy,field,gc,x1,y1,x2-x1,y2-y1,0,360*64);
			puck.last_X = puck.x;
			puck.last_Y = puck.y;
			break;
	}

	XFlush(dpy);
}
