/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "puck.h"

extern Display *dpy;
extern Window field;
extern GC gc;
extern long black,white;

extern Puck puck;
extern Game game;
Racket racket;
Racket racket2;

init_racket()
{
	racket.x = 0.0;
	racket.y = 0.0;
	racket.dx = 0.0;
	racket.dy = 0.0;
	racket.last_x = racket.x;
	racket.last_y = racket.y;
	if (game.mode == GAME_AUTO)
	{
		game.init_racket2();
	}
}

move_racket(XEvent event)
{
	racket.last_y = racket.y;
	racket.last_x = racket.x;

	racket.y = event.xmotion.x-FIELD_WIDTH/2;
	racket.x = FIELD_HEIGHT-event.xmotion.y;

	racket.dx = racket.x-racket.last_x;
	racket.dy = racket.y-racket.last_y;

	if (racket.y < (-GAME_WIDTH/2+RACKET_WIDTH/2)) racket.y = -GAME_WIDTH/2+RACKET_WIDTH/2;
	if (racket.y > (GAME_WIDTH/2-RACKET_WIDTH/2)) racket.y =  GAME_WIDTH/2-RACKET_WIDTH/2;
	if (racket.x >  GAME_PLAYER_ZONE) racket.x =  GAME_PLAYER_ZONE;
	if (racket.x <  0) racket.x =  0;

	check_colision_racket_with_puck();
}

draw_racket2(int mode)
{
	long x1,y1,x2,y2;

	switch (mode)
	{
		case 0:
			x1 = proj_x(racket2.last_X,racket2.last_Y-RACKET_WIDTH/2,RACKET_HEIGHT);
			x2 = proj_x(racket2.last_X,racket2.last_Y+RACKET_WIDTH/2,0);
			y1 = proj_y(racket2.last_X,racket2.last_Y-RACKET_WIDTH/2,RACKET_HEIGHT);
			y2 = proj_y(racket2.last_X,racket2.last_Y+RACKET_WIDTH/2,0);
			XClearArea(dpy,field,x1,y1,x2-x1,y2-y1,False);
			break;
		case 1:
			racket2.last_X = racket2.x;
			racket2.last_Y = racket2.y;

			x1 = proj_x(racket2.x,racket2.y-RACKET_WIDTH/2,RACKET_HEIGHT);
			x2 = proj_x(racket2.x,racket2.y+RACKET_WIDTH/2,0);
			y1 = proj_y(racket2.x,racket2.y-RACKET_WIDTH/2,RACKET_HEIGHT);
			y2 = proj_y(racket2.x,racket2.y+RACKET_WIDTH/2,0);
			XSetForeground(dpy,gc,get_color(7));
			XFillRectangle(dpy,field,gc,x1,y1,x2-x1,y2-y1);
			break;
	}

	XFlush(dpy);
}

draw_racket(int mode)
{
	long x1,y1,x2,y2,xg,yg,xd,yd,xbg,ybg,xbd,ybd;
	XPoint rkt[6],left[4],right[4];

	switch (mode)
	{
		case 0:
			x1 = proj_x(racket.last_X,racket.last_Y-RACKET_WIDTH/2,RACKET_HEIGHT);
			x2 = proj_x(racket.last_X,racket.last_Y+RACKET_WIDTH/2,0);
			y1 = proj_y(racket.last_X+10,racket.last_Y-RACKET_WIDTH/2,RACKET_HEIGHT);
			y2 = proj_y(racket.last_X,racket.last_Y+RACKET_WIDTH/2,0);
			XClearArea(dpy,field,x1-10,y1,x2-x1+20,y2-y1,False);
			break;
		case 1:
			racket.last_X = racket.x;
			racket.last_Y = racket.y;

			x1 = proj_x(racket.x,racket.y-RACKET_WIDTH/2,RACKET_HEIGHT);
			x2 = proj_x(racket.x,racket.y+RACKET_WIDTH/2,0);
			y1 = proj_y(racket.x,racket.y-RACKET_WIDTH/2,RACKET_HEIGHT);
			y2 = proj_y(racket.x,racket.y+RACKET_WIDTH/2,0);

			xg = proj_x(racket.x+10,racket.y-RACKET_WIDTH/2,RACKET_HEIGHT);
			yg = proj_y(racket.x+10,racket.y-RACKET_WIDTH/2,RACKET_HEIGHT);

			xd = proj_x(racket.x+10,racket.y+RACKET_WIDTH/2,RACKET_HEIGHT);
			yd = proj_y(racket.x+10,racket.y+RACKET_WIDTH/2,RACKET_HEIGHT);

			xbg = proj_x(racket.x+10,racket.y-RACKET_WIDTH/2,0);
			ybg = proj_y(racket.x+10,racket.y-RACKET_WIDTH/2,0);

			xbd = proj_x(racket.x+10,racket.y+RACKET_WIDTH/2,0);
			ybd = proj_y(racket.x+10,racket.y+RACKET_WIDTH/2,0);

			rkt[0].x = x1; rkt[0].y = y1;
			rkt[1].x = x1; rkt[1].y = y2;
			rkt[2].x = x2; rkt[2].y = y2;
			rkt[3].x = x2; rkt[3].y = y1;
			rkt[4].x = xd; rkt[4].y = yd;
			rkt[5].x = xg; rkt[5].y = yg;

			left[0].x = x1; left[0].y = y1;
			left[1].x = xg; left[1].y = yg;
			left[2].x = xbg; left[2].y = ybg;
			left[3].x = x1; left[3].y = y2;

			right[0].x = x2; right[0].y = y1;
			right[1].x = xd; right[1].y = yd;
			right[2].x = xbd; right[2].y = ybd;
			right[3].x = x2; right[3].y = y2;

			XSetForeground(dpy,gc,get_color(4));
			XFillPolygon(dpy,field,gc,left,4,Convex,CoordModeOrigin);
			XFillPolygon(dpy,field,gc,right,4,Convex,CoordModeOrigin);
			XSetForeground(dpy,gc,get_color(5));
			XFillPolygon(dpy,field,gc,rkt,6,Nonconvex,CoordModeOrigin);

			XSetForeground(dpy,gc,black);
			XDrawRectangle(dpy,field,gc,x1+1,y1+1,x2-x1-3,y2-y1-3);
			break;
	}

	XFlush(dpy);
}
