/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <assert.h>
#include "puck.h"

#define SYNCHRO     0x12345678
#define SLAVE_MOVE  0x87654321

extern Game game;
extern Racket racket,racket2;
extern Puck puck;

struct {
	State	state;
	int	score[2];
	int	set;
	int	ready;
	Racket	racket;
	Racket	racket2;
	Puck	puck;
} to_slave;

struct {
	int synchro;
	int x,y;	/* Racket wants to move to x,y */
	int ready;	/* Player is ready */
} to_master;

tell_size()
{
	printf("to_slave = %d, to_master = %d\n",sizeof(to_slave),sizeof(to_master));
}

send_master()
{
	to_master.synchro = SLAVE_MOVE;
	to_master.x = GAME_DEPTH-racket.x;
	to_master.y = -racket.y;
	to_master.ready = game.ready[0];
	socket_write(&to_master,sizeof(to_master));
	/* printf("Sent to master\n"); */
}

recv_master()
{
	int s;
	socket_read(&to_slave, sizeof(to_slave));
	game.state = to_slave.state;
	s = to_slave.set;
	game.set      = s;
	game.score[s][0] = to_slave.score[1];
	game.score[s][1] = to_slave.score[0];
	game.ready[1] = to_slave.ready;
	/* Change coordinates for master */
	racket2.last_x = racket2.x;
	racket2.last_y = racket2.y;
	racket2.x = GAME_DEPTH-to_slave.racket.x;
	racket2.y = -to_slave.racket.y;
	racket.last_x = racket.x;
	racket.last_y = racket.y;
	racket.x = GAME_DEPTH-to_slave.racket2.x;
	racket.y = -to_slave.racket2.y;
	puck.last_x = puck.x;
	puck.last_y = puck.y;
	puck.x = GAME_DEPTH-to_slave.puck.x;
	puck.y = -to_slave.puck.y;

	/* Synchro part */
	to_master.synchro = SYNCHRO;
	socket_write(&to_master,sizeof(to_master));
	/* printf("Synchro to master\n"); */
}

send_slave()
{
	int s;

	s = game.set;
	to_slave.state = game.state;
	to_slave.score[0] = game.score[s][0];
	to_slave.score[1] = game.score[s][1];
	to_slave.set	  = s;
	to_slave.ready = game.ready[0];
	to_slave.racket = racket;
	to_slave.racket2 = racket2;
	to_slave.puck = puck;
	socket_write(&to_slave, sizeof(to_slave));
	/* printf("Sent to slave\n"); */

	/* Synchro */
	while(1) {
		socket_read(&to_master, sizeof(to_master));
		/* printf("Synchro = %x\n",to_master.synchro); */
#ifdef DEBUG
		assert(to_master.synchro == SLAVE_MOVE || to_master.synchro == SYNCHRO);
#endif /* DEBUG */
		if (to_master.synchro == SLAVE_MOVE)
		{
			racket2.x = to_master.x;
			racket2.y = to_master.y;
			game.ready[1] = to_master.ready;
		}
		else
		{
			break;
		}
	}
}

recv_slave()
{
	socket_read(&to_master,sizeof(to_master));
#ifdef DEBUG
	assert(to_master.synchro == SLAVE_MOVE);
#endif /* DEBUG */
	racket2.last_x = racket2.x;
	racket2.last_y = racket2.y;
	racket2.x = to_master.x;
	racket2.y = to_master.y;
	racket2.dx = racket2.x-racket2.last_x;
	racket2.dy = racket2.y-racket2.last_y;
	game.ready[1] = to_master.ready;
}
