/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <stdio.h>
#include <X11/Xlib.h>
#include "puck.h"

extern Display *dpy;
extern GC gc;
extern Window panel,field;
extern XFontStruct * font[];
extern Game game;
extern long white,black;

display_score()
{
	char buffer[256];
	int set,s;

	s = game.set;
	sprintf(buffer,"Xpuck");
	XSetFunction(dpy,gc,GXcopy);
	XSetFont(dpy,gc,font[FONT_DIGIT]->fid);
	XSetBackground(dpy,gc,black);
	XSetForeground(dpy,gc,white);
	XDrawImageString(dpy,panel,gc,20,30,buffer,strlen(buffer));

	XSetFont(dpy,gc,font[FONT_SCORE]->fid);
	XSetBackground(dpy,gc,black);
	XSetForeground(dpy,gc,white);
	XSetLineAttributes(dpy,gc,2,LineSolid,CapButt,JoinBevel);
	XDrawRectangle(dpy,field,gc,15,5,85+NB_SETS*25,40);
	XSetLineAttributes(dpy,gc,1,LineSolid,CapButt,JoinBevel);
	XDrawLine(dpy,field,gc,15,25,100+NB_SETS*25,25);
	XDrawImageString(dpy,field,gc,20,20,game.my_name,strlen(game.my_name));
	XDrawImageString(dpy,field,gc,20,20+20,game.opponent_name,strlen(game.opponent_name));
	for(set=0; set < NB_SETS; set++)
	{
		XDrawLine(dpy,field,gc,100+set*25,5,100+set*25,45);
		if (set > game.set)
		{
			XDrawImageString(dpy,field,gc,100+25*set+5,20," -",strlen(" -"));
			XDrawImageString(dpy,field,gc,100+25*set+5,20+20," -",strlen(" -"));
		}
		else
		{
			sprintf(buffer,"%2d",game.score[set][0]);
			XDrawImageString(dpy,field,gc,100+25*set+5,20,buffer,strlen(buffer));
			sprintf(buffer,"%2d",game.score[set][1]);
			XDrawImageString(dpy,field,gc,100+25*set+5,20+20,buffer,strlen(buffer));
		}
	}
	XFlush(dpy);
}

int
score(int p1,int p2)
{
	int s;

	s = game.set;
	game.score[s][0] += p1;
	game.score[s][1] += p2;
	display_score();
	return (game.score[s][0] == POINT_MAX || game.score[s][1] == POINT_MAX);
}

reset_score()
{
	int s;

	for(s=0; s < NB_SETS; s++)
	{
		game.score[s][0] = 0;
		game.score[s][1] = 0;
	}
	game.set = 0;
}

int
match_is_over()
{
	int s,p1,p2;

	p1 = p2 = 0;
	for(s=0; s < NB_SETS; s++)
	{
		if (game.score[s][0] == POINT_MAX) p1++;
		if (game.score[s][1] == POINT_MAX) p2++;
	}
	if (p1 >= (NB_SETS/2+1)) return 0;
	if (p2 >= (NB_SETS/2+1)) return 1;
	return -1;
}
