/**********************************************************/
/**                                                       */
/**   %Z% %M% Version %I% (%G%)                           */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   AUTEUR :  O.DEBON                                   */
/**                                                       */
/**   DATE DE CREATION :  23/12/96                        */
/**                                                       */
/**********************************************************/
/**                                                       */
/**   MODIFICATIONS :                                     */
/**                                                       */
/**   Date         Auteur           Commentaires          */
/**                                                       */
/**                                                       */
/**********************************************************/
static char *sccs_id = "%Z% %M% Version %I% (%G%)";
#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <netinet/in.h>
#include <sys/time.h>
#include <signal.h>
#include <assert.h>

#include <errno.h>
extern int errno;

#ifdef TICK
#undef TICK
#endif

#include "puck.h"

extern Game game;

static int                 socket_in;
static int                 socket_out;
static struct sockaddr_in  param_in;
static struct sockaddr_in  param_out;

static struct hostent     *host_descrypt;   /* parametres du socket-host */
struct hostent     *gethostbyname(); /* peut etre inutile */

void init_client(char *, int);

#define BUF_LENGTH 256

#ifdef DEBUG
long out = 0;
long in = 0;
#endif

int
init_server(int port)
{
	socket_in = socket(AF_INET,SOCK_DGRAM,0);
	if (socket_in < 0)
	{
		perror("Opening socket stream failed ... ");
		exit(1);
	}
	param_in.sin_family      = AF_INET; 
	param_in.sin_addr.s_addr = htonl(INADDR_ANY);
	param_in.sin_port        = htons(port);
	if (bind(socket_in,(struct sockaddr *)&param_in,sizeof(param_in)) < 0)
	{
		perror("Binding socket failed ...");
		exit(1);
	}
	return socket_in;
}

int
wait_for_client()
{
	Connection connection;

	socket_read(&connection,sizeof(connection));
	strcpy(game.opponent_name,connection.player_name);
	strcpy(game.opponent_xpm_file,connection.xpm_file);
	printf("Opponent is %s\n",game.opponent_name);
	init_client("localhost",connection.port);
	param_out.sin_addr = param_in.sin_addr;
	/* printf("Sender : %s\n",inet_ntoa(param_out.sin_addr)); */
	strcpy(connection.player_name, game.my_name);
	strcpy(connection.xpm_file, game.xpm_file);
	socket_write(&connection,sizeof(connection));
	return socket_in;
}

int
connect_to_server()
{
	Connection connection;
	fd_set fdset;
	struct timeval  timeout;
	int status;

	connection.port = game.port+1;
	strcpy(connection.player_name, game.my_name);
	strcpy(connection.xpm_file, game.xpm_file);
	while(1)
	{
		socket_write(&connection,sizeof(connection));
		FD_ZERO(&fdset);
		FD_SET(socket_in,&fdset);
		timeout.tv_sec = 2;
		timeout.tv_usec = 0;
		status = select(socket_in+1,&fdset,0,0,&timeout);
		if (status)
		{
			socket_read(&connection,sizeof(connection));
			break;
		}
		else
		{
			printf("Retrying...\n");
		}
	}
	strcpy(game.opponent_name,connection.player_name);
	strcpy(game.opponent_xpm_file,connection.xpm_file);
	printf("Opponent is %s\n",game.opponent_name);
}

void
init_client(char *host, int port)
{
	socket_out = socket(AF_INET,SOCK_DGRAM,0);
	if (socket_out < 0)
	{
		perror("cannot create socket ...");
		return;
	}
	param_out.sin_family = AF_INET;
	/* gethostname(host,sizeof(host)); */
	host_descrypt = gethostbyname(host);
	if (host_descrypt == 0)
	{
		perror(host);
		return;
	}
	memcpy( (char *)&param_out.sin_addr, (char *)host_descrypt->h_addr, host_descrypt->h_length);
	param_out.sin_port = htons(port);
}

close_server()
{
	close(socket_out);
}

close_client()
{
	close(socket_in);
}

int
socket_write(char *buf, int length)
{
	int status;

	while (length)
	{
		status = sendto(socket_out,buf,length,0,(struct sockaddr *)&param_out,sizeof(param_out));
#ifdef DEBUG
		printf("Write(%5d) = %5d  to %s/%d\n",out++,status,inet_ntoa(param_out.sin_addr),param_out.sin_port);
#endif
		switch (status)
		{
			case 0:
				/* Closed */
				exit(1);
				break;
			case -1:
#ifdef DEBUG
				assert(errno == EINTR);
#endif /* DEBUG */
				break;
			default:
				buf += status;
				length -= status;
				break;
		}
	}
}

int
socket_read(char *buf, int length)
{
	int status;
	int l;

	while (length)
	{
		l = sizeof(param_in);
		status = recvfrom(socket_in,buf,length,0,(struct sockaddr *)&param_in,&l);
#ifdef DEBUG
		printf("Read(%5d) = %5d  from %s/%d\n",in++,status,inet_ntoa(param_in.sin_addr),param_in.sin_port);
#endif
		switch (status)
		{
			case 0:
				/* Closed */
				close_client();
				close_server();
				exit(1);
				break;
			case -1:
				/* Retry */
#ifdef DEBUG
				assert(errno == EINTR);
#endif /* DEBUG */
				break;
			default:
				buf += status;
				length -= status;
				break;
		}
	}
}
